/**
 * <p>^Cg: vWFNg "Taglib&JSTL"</p>
 * <p>: -</p>
 * <p>쌠: Copyright (c) 2005 by Taka Tazawa. All Rights Reserved.</p>
 * @author Taka Tazawa
 * @since 2005/01/30
 * @version 1.0
 */
package example002.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;
import util.exception.UnexpectedException;

public class ItemServlet extends HttpServlet {

    static final long serialVersionUID = 1L;

    private static final String DATASOURCE = "MyDataSource";

    public static final int GETITEMSALL = 1;
    public static final int GETITEMSBYNAME = 2;
    public static final int GETITEMSBYCATEGORY = 3;
    public static final int GETITEMSBYNAMEANDCATEGORY = 4;

    private static final String SQLSELECT = "SELECT ITEM.ITEM_ID, ITEM.NAME, CATEGORY.CATEGORY_NAME, ITEM.PRICE, ITEM.DETAIL, ITEM.INVALIDATED_DATE, ITEM.LEAD_TIME, ITEM.REGISTRATION_DATE FROM ITEM, CATEGORY WHERE ITEM.CATEGORY_ID=CATEGORY.CATEGORY_ID ";
    private static final String SQLORDERBY = "ORDER BY ITEM_ID ";
    private static final String SQLCOUNT = "SELECT COUNT(*) FROM ITEM, CATEGORY WHERE ITEM.CATEGORY_ID=CATEGORY.CATEGORY_ID ";

    public void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {

        String name = "";
        String category = "";

        Context ctx =null;
        Connection conn = null;
        int rowCount = 0;
        ResultSet rs = null;
        PreparedStatement pstmt = null;

        response.setContentType("text/html;charset=Shift_JIS");
        PrintWriter out = response.getWriter();

        out.println("<html>");
        out.println("<head><title>example002</title></head>");
        out.println("<body>");
        out.println("<table width=\"100%\" CELLSPACING=\"0\" border=\"0\" cellpadding=\"0\">");
        out.println("<tr>");
        out.println("<td colspan=\"2\">");
        RequestDispatcher rd = request.getRequestDispatcher("/resources/jsp/header.jsp");
        rd.include(request, response);
        out.println("</td></tr>");
        out.println("<tr>");
        out.println("<td colspan=\"2\">");
        rd = request.getRequestDispatcher("/example002/menu.jsp");
        rd.include(request, response);
        out.println("</td></tr>");
        out.println("<tr><td valign=\"top\" width=\"5%\">");
        rd = request.getRequestDispatcher("/resources/jsp/navigation.jsp");
        rd.include(request, response);
        out.println("</td><td valign=\"top\">");
        out.println("<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" bgcolor=\"White\" class=\"body\">");
        out.println("<tr bgcolor=\"#9999ff\">");
        out.println("<td>ǐ</td>");
        out.println("</tr>");
        out.println("<tr>");
        out.println("<td>&nbsp</td>");
        out.println("</tr>");
        out.println("<tr>");
        out.println("<td nowrap>");

        try {

            name = request.getParameter("name");
            category = request.getParameter("category");
            System.out.println(">>>>  [" + name + "] [" + category+ "]");

            ctx = new InitialContext();
            DataSource ds = (javax.sql.DataSource) ctx.lookup("java:comp/env/jdbc/" + DATASOURCE);
            conn = ds.getConnection();

            if (name.equals("") && category.equals("")) {
                System.out.println("getItemsAll");

                rowCount = getRowCount(GETITEMSALL, name, category, conn, pstmt);
                rs = getItems(conn, GETITEMSALL, name, category);

            } else if (category.equals("")) {
                System.out.println("getItemsByName");

                rowCount = getRowCount(GETITEMSBYNAME, name, category, conn, pstmt);
                rs = getItems(conn, GETITEMSBYNAME, name, category);

            } else if (name.equals("")) {
                System.out.println("getItemsByCategory");

                rowCount = getRowCount(GETITEMSBYCATEGORY, name, category, conn, pstmt);
                rs = getItems(conn, GETITEMSBYCATEGORY, name, category);

            } else {
                System.out.println("getItemsByNameAndCategory");

                rowCount = getRowCount(GETITEMSBYNAMEANDCATEGORY, name, category, conn, pstmt);
                rs = getItems(conn, GETITEMSBYNAMEANDCATEGORY, name, category);

            }

            out.println("<table border=\"0\" cellpadding=\"0\" bgcolor=\"#fffffe\" width=\"100%\" class=\"body\">");
            out.println("<tr>");
            out.println("<td colspan=\"5\">");
            out.println("Yi <B>" + rowCount + "</B> ");
            out.println("</td>");
            out.println("</tr>");

            out.println("<tr bgcolor=\"#00ffff\">");
            out.println("<th>i</th>");
            out.println("<th>JeS</th>");
            out.println("<th>i</th>");
            out.println("</tr>");

            while (rs.next()) {
                out.println("<tr>");
                out.println("<td>" + rs.getString("NAME") + "</td>");
                out.println("<td>" + rs.getString("CATEGORY_NAME") + "</td>");
                out.println("<td align=\"right\">" + rs.getString("PRICE") + "~</td>");
                out.println("</tr>");
            }

            out.println("</table>");
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (conn != null)
                    conn.close();
                if (pstmt != null)
                    pstmt.close();
                ctx.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        out.println("</td></tr></table>");
        out.println("</td></tr><tr><td COLSPAN=\"2\">");
        rd = request.getRequestDispatcher("/resources/jsp/footer.jsp");
        rd.include(request, response);
        out.println("</td></tr></table></body></html>");
    }

    public void doGet(HttpServletRequest req, HttpServletResponse res) throws IOException, ServletException {
        doPost(req, res);
    }

    public int getRowCount(int whichSearch, String name, String category, Connection conn, PreparedStatement pstmt) throws UnexpectedException {

        String sqlWhere = "";
        ResultSet rs = null;

        switch (whichSearch) {
            case GETITEMSALL: 
                sqlWhere = "";
                break;
            case GETITEMSBYNAME:
                sqlWhere = "AND ITEM.NAME LIKE ? ";
                break;
            case GETITEMSBYCATEGORY: 
                sqlWhere = "AND ITEM.CATEGORY_ID = ? ";
                break;
            case GETITEMSBYNAMEANDCATEGORY: 
                sqlWhere = "AND ITEM.NAME LIKE ? AND ITEM.CATEGORY_ID = ? ";
                break;
            default:
                break;
        }

        try {
            pstmt = conn.prepareStatement(SQLCOUNT + sqlWhere);
            switch (whichSearch) {
                case GETITEMSALL: 
                    break;
                case GETITEMSBYNAME:
                    pstmt.setString(1, "%" + name + "%");
                    break;
                case GETITEMSBYCATEGORY: 
                    pstmt.setString(1, category);
                    break;
                case GETITEMSBYNAMEANDCATEGORY: 
                    pstmt.setString(1, "%" + name + "%");
                    pstmt.setString(2, category);
                    break;
                default:
                    break;
            }
    
            pstmt.executeQuery();
            rs = pstmt.getResultSet();
            rs.next();
            return rs.getInt(1);
        } catch(SQLException e) {
            e.printStackTrace();
            throw new UnexpectedException();
        } finally {
        }
    }

    public ResultSet getItems(Connection conn, int whichSearch, String name, String category) throws UnexpectedException {

        String sqlWhere = "";
        PreparedStatement pstmt = null;
        ResultSet rs = null;

        switch (whichSearch) {
            case GETITEMSALL: 
                sqlWhere = "";
                break;
            case GETITEMSBYNAME:
                sqlWhere = "AND ITEM.NAME LIKE ? ";
                break;
            case GETITEMSBYCATEGORY: 
                sqlWhere = "AND ITEM.CATEGORY_ID = ? ";
                break;
            case GETITEMSBYNAMEANDCATEGORY: 
                sqlWhere = "AND ITEM.NAME LIKE ? AND ITEM.CATEGORY_ID = ? ";
                break;
            default:
                break;
        }
    
        try {
            pstmt = conn.prepareStatement(SQLSELECT + sqlWhere + SQLORDERBY);
            switch (whichSearch) {
                case GETITEMSALL: 
                    break;
                case GETITEMSBYNAME:
                    pstmt.setString(1, "%" + name + "%");
                    break;
                case GETITEMSBYCATEGORY: 
                    pstmt.setString(1, category);
                    break;
                case GETITEMSBYNAMEANDCATEGORY: 
                    pstmt.setString(1, "%" + name + "%");
                    pstmt.setString(2, category);
                    break;
                default:
                    break;
            }
            pstmt.executeQuery();
            rs = pstmt.getResultSet();
            return rs;
        } catch(SQLException e) {
            throw new UnexpectedException();
        } finally {
        }
    }

}
