/**
 * <p>^Cg: vWFNg "Taglib&JSTL"</p>
 * <p>: -</p>
 * <p>쌠: Copyright (c) 2005 by Taka Tazawa. All Rights Reserved.</p>
 * @author Taka Tazawa
 * @since 2005/01/30
 * @version 1.0
 */
package example003.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Collection;
import java.util.Iterator;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import util.dao.ItemDAO;
import util.dao.exception.DAOException;
import util.dao.exception.DAOFactoryException;
import util.dao.factory.DAOFactory;
import util.to.ItemTO;

public class ItemServlet extends HttpServlet {

    static final long serialVersionUID = 1L;

    private static final String DATASOURCE = "MyDataSource";

    public void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {

        ServletContext context = this.getServletContext();
        String taxRate = context.getInitParameter("TAX_RATE");

        String name = "";
        String category = "";
        Collection items = null;

        response.setContentType("text/html;charset=Shift_JIS");
        PrintWriter out = response.getWriter();

        out.println("<html>");
        out.println("<head><title>example003</title></head>");
        out.println("<body>");
        out.println("<table width=\"100%\" CELLSPACING=\"0\" border=\"0\" cellpadding=\"0\" class=\"body\">");
        out.println("<tr>");
        out.println("<td colspan=\"2\">");
        RequestDispatcher rd = request.getRequestDispatcher("/resources/jsp/header.jsp");
        rd.include(request, response);
        out.println("</td></tr>");
        out.println("<tr>");
        out.println("<td colspan=\"2\">");
        rd = request.getRequestDispatcher("/example003/menu.jsp");
        rd.include(request, response);
        out.println("</td></tr>");
        out.println("<tr><td valign=\"top\" width=\"5%\">");
        rd = request.getRequestDispatcher("/resources/jsp/navigation.jsp");
        rd.include(request, response);
        out.println("</td><td valign=\"top\">");
        out.println("<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" bgcolor=\"White\">");
        out.println("<tr bgcolor=\"#9999ff\">");
        out.println("<td>ǐ</td>");
        out.println("</tr>");
        out.println("<tr>");
        out.println("<td>&nbsp</td>");
        out.println("</tr>");
        out.println("<tr>");
        out.println("<td nowrap>");

        try {
            name = request.getParameter("name");
            category = request.getParameter("category");
            System.out.println(">>>>  [" + name + "] [" + category+ "]");

            ItemDAO itemDAO = null;
            DAOFactory factory = DAOFactory.getDAOFactory();

            if (name.equals("") && category.equals("")) {
                System.out.println("getItemsAll");
                itemDAO = factory.getItemDAO();
                items = itemDAO.getItemsAll();
            } else if (category.equals("")) {
                System.out.println("getItemsByName");
                itemDAO = factory.getItemDAO();
                items = itemDAO.getItemsByName(name);
            } else if (name.equals("")) {
                System.out.println("getItemsByCategory");
                itemDAO = factory.getItemDAO();
                items = itemDAO.getItemsByCategory(category);
            } else {
                System.out.println("getItemsByNameAndCategory");
                itemDAO = factory.getItemDAO();
                items = itemDAO.getItemsByNameAndCategory(name, category);
            }
        } catch(DAOException e){
            e.printStackTrace();
        } catch(DAOFactoryException e){
            e.printStackTrace();
        }

        out.println("<table border=\"0\" cellpadding=\"0\" bgcolor=\"#fffffe\" width=\"100%\" class=\"body\">");
        out.println("<tr>");
        out.println("<td colspan=\"5\">");
        out.println("Yi <B>" + items.size() + "</B> ");
        out.println("</td>");
        out.println("</tr>");

        out.println("<tr bgcolor=\"#00ffff\">");
        out.println("<th>i</th>");
        out.println("<th>JeS</th>");
        out.println("<th>i</th>");
        out.println("</tr>");

        Iterator it = items.iterator();

        while (it.hasNext()) {
            ItemTO item = (ItemTO) it.next();
            out.println("<tr>");
            out.println("<td>" + item.getName() + "</td>");
            out.println("<td>" + item.getCategory() + "</td>");
            out.println("<td align=\"right\">" + item.getPrice() + "~</td>");
            out.println("</tr>");
        }

        out.println("</table>");
        out.println("</td></tr></table>");
        out.println("</td></tr><tr><td COLSPAN=\"2\">");
        rd = request.getRequestDispatcher("/resources/jsp/footer.jsp");
        rd.include(request, response);
        out.println("</td></tr></table></body></html>");
    }

    public void doGet(HttpServletRequest req, HttpServletResponse res) throws IOException, ServletException {
        doPost(req, res);
    }

}
