/**
 * <p>^Cg: vWFNg "Taglib&JSTL"</p>
 * <p>: -</p>
 * <p>쌠: Copyright (c) 2005 by Taka Tazawa. All Rights Reserved.</p>
 * @author Taka Tazawa
 * @since 2005/01/30
 * @version 1.0
 */
package example022.struts.action;

import java.util.Collection;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import struts.form.ItemSearchForm;
import util.dao.ItemDAO;
import util.dao.exception.DAOException;
import util.dao.exception.DAOFactoryException;
import util.dao.factory.DAOFactory;
import util.exception.IteratorException;
import util.logic.ValueListHandler;
import util.logic.ValueListIterator;

public class ItemSearchAction extends Action {

    private ValueListIterator result;

    public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest req, HttpServletResponse res) {
    
        // ʂ̍폜
        req.getSession().removeAttribute("result");
        req.getSession().removeAttribute("size");
        // ̍폜
        req.getSession().removeAttribute("search_name");
        req.getSession().removeAttribute("search_category");

        ItemDAO itemDAO = null;
        Collection items = null;

        ItemSearchForm _form = (ItemSearchForm)form;
        String name = _form.getName();
        String category = _form.getCategory();
        System.out.println(">>>>  [" + name + "] [" + category+ "]");

        DAOFactory factory = DAOFactory.getDAOFactory();

        try {
            if (name.equals("") && category.equals("")) {
                System.out.println("getItemsAll");
                itemDAO = factory.getItemDAO();
                result = new ValueListHandler(5);
                List list = (List)itemDAO.getItemsAll();
                result.setList(list);
            } else if (category.equals("")) {
                System.out.println("getItemsByName");
                itemDAO = factory.getItemDAO();
                result = new ValueListHandler(5);
                List list = (List)itemDAO.getItemsByName(name);
                result.setList(list);
            } else if (name.equals("")) {
                System.out.println("getItemsByCategory");
                itemDAO = factory.getItemDAO();
                result = new ValueListHandler(5);
                List list = (List)itemDAO.getItemsByCategory(category);
                result.setList(list);
            } else {
                System.out.println("getItemsByNameAndCategory");
                itemDAO = factory.getItemDAO();
                result = new ValueListHandler(5);
                List list = (List)itemDAO.getItemsByNameAndCategory(name, category);
                result.setList(list);
            }
        } catch(IteratorException e){
            return mapping.findForward("fail");
        } catch(DAOException e){
            return mapping.findForward("fail");
        } catch(DAOFactoryException e){
            return mapping.findForward("fail");
        }
        
        // ʂ̕ۑ
        req.getSession().setAttribute("result", result);
        req.getSession().setAttribute("size", new Integer(result.getSize()).toString());
        // ̕ۑ
        req.getSession().setAttribute("search_name", _form.getName());
        req.getSession().setAttribute("search_category", _form.getCategory());

        items = result.getCurrentElements();
        // ݂̃y[Wۑ
        req.setAttribute("page", result.getCurrentPage() + "/" + result.getPageSize());
        // ݂̃y[W̏iۑ
        req.setAttribute("items", items);
        return mapping.findForward("success");
    }

}
