/**
 * <p>^Cg: vWFNg "Taglib&JSTL"</p>
 * <p>: -</p>
 * <p>쌠: Copyright (c) 2005 by Taka Tazawa. All Rights Reserved.</p>
 * @author Taka Tazawa
 * @since 2005/01/30
 * @version 1.0
 */
package util.dao.factory; 

import java.sql.Connection;
import java.sql.SQLException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;
import util.dao.ItemDAO;
import util.dao.RdbItemDAO;
import util.dao.exception.DAOFactoryException;

public class RdbDAOFactory extends DAOFactory {

    static final String DATASOURCE="MyDataSource";

    public static Connection createConnection() throws DAOFactoryException {
        System.out.println("RdbDAOFactory:createConnection");
        
        Context ctx = null;
        Connection conn = null;

        try {
            ctx = new InitialContext();
            DataSource ds = (javax.sql.DataSource)ctx.lookup("java:comp/env/jdbc/" + DATASOURCE);
            conn = ds.getConnection();
        } catch (NamingException e) {
            throw new DAOFactoryException("NamingException", e);
        } catch (SQLException e) {
            throw new DAOFactoryException("SQLException", e);
        } finally {
            try {
                ctx.close();
            } catch (NamingException e) {
                throw new DAOFactoryException("NamingException", e);
            }
        }
        return conn;
    }

    public ItemDAO getItemDAO() {
        System.out.println("RdbDAOFactory:getItemDAO");
        return new RdbItemDAO();
    }

}

