/**
 * <p>^Cg: vWFNg "Taglib&JSTL"</p>
 * <p>: -</p>
 * <p>쌠: Copyright (c) 2005 by Taka Tazawa. All Rights Reserved.</p>
 * @author Taka Tazawa
 * @since 2005/01/30
 * @version 1.0
 */
package util.logic; 

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import util.exception.UnexpectedException;

public class Item {
    
    public Item() {
    }

    public static final int GETITEMSALL = 1;
    public static final int GETITEMSBYNAME = 2;
    public static final int GETITEMSBYCATEGORY = 3;
    public static final int GETITEMSBYNAMEANDCATEGORY = 4;

    private static final String DATASOURCE = "MyDataSource";
    private static final String SQLSELECT = "SELECT ITEM_ID, NAME, CATEGORY, PRICE, DETAIL, INVALIDATED_DATE, LEAD_TIME FROM ITEM ";
    private static final String SQLCOUNT = "SELECT COUNT(*) FROM ITEM ";
    private static final String SQLORDERBY = "ORDER BY ITEM_ID ";

    public int getRowCount(Connection conn, int whichSearch, String name, String category) throws SQLException {

        String sqlWhere = "";
        ResultSet rs = null;
        PreparedStatement pstmt = null;

        switch (whichSearch) {
            case GETITEMSALL: 
                sqlWhere = "";
                break;
            case GETITEMSBYNAME:
                sqlWhere = "WHERE NAME LIKE ? ";
                break;
            case GETITEMSBYCATEGORY: 
                sqlWhere = "WHERE CATEGORY = ? ";
                break;
            case GETITEMSBYNAMEANDCATEGORY: 
                sqlWhere = "WHERE NAME LIKE ? AND CATEGORY = ? ";
                break;
            default:
                break;
        }

        pstmt = conn.prepareStatement(SQLCOUNT + sqlWhere);
        switch (whichSearch) {
            case GETITEMSALL: 
                break;
            case GETITEMSBYNAME:
                pstmt.setString(1, "%" + name + "%");
                break;
            case GETITEMSBYCATEGORY: 
                pstmt.setString(1, category);
                break;
            case GETITEMSBYNAMEANDCATEGORY: 
                pstmt.setString(1, "%" + name + "%");
                pstmt.setString(2, category);
                break;
            default:
                break;
        }

        pstmt.executeQuery();
        rs = pstmt.getResultSet();
        rs.next();
        
        return Integer.parseInt(rs.getString("COUNT(*)"));
    }

    public ResultSet getItems(Connection conn, int whichSearch, String name, String category) throws UnexpectedException {

        String sqlWhere = "";
        ResultSet rs = null;
        PreparedStatement pstmt = null;

        try {
            switch (whichSearch) {
                case GETITEMSALL: 
                    sqlWhere = "";
                    break;
                case GETITEMSBYNAME:
                    sqlWhere = "WHERE NAME LIKE ? ";
                    break;
                case GETITEMSBYCATEGORY: 
                    sqlWhere = "WHERE CATEGORY = ? ";
                    break;
                case GETITEMSBYNAMEANDCATEGORY: 
                    sqlWhere = "WHERE NAME LIKE ? AND CATEGORY = ? ";
                    break;
                default:
                    break;
            }
    
            pstmt = conn.prepareStatement(SQLSELECT + sqlWhere + SQLORDERBY);
            switch (whichSearch) {
                case GETITEMSALL: 
                    break;
                case GETITEMSBYNAME:
                    pstmt.setString(1, "%" + name + "%");
                    break;
                case GETITEMSBYCATEGORY: 
                    pstmt.setString(1, category);
                    break;
                case GETITEMSBYNAMEANDCATEGORY: 
                    pstmt.setString(1, "%" + name + "%");
                    pstmt.setString(2, category);
                    break;
                default:
                    break;
            }
    
            pstmt.executeQuery();
            return pstmt.getResultSet();
        } catch(SQLException e) {
            throw new UnexpectedException();
        } finally {
            try {
                if (pstmt != null)
                    pstmt.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

} 
