/**
 * <p>^Cg: vWFNg "Taglib&JSTL"</p>
 * <p>: -</p>
 * <p>쌠: Copyright (c) 2005 by Taka Tazawa. All Rights Reserved.</p>
 * @author Taka Tazawa
 * @since 2005/01/30
 * @version 1.0
 */
package util.logic; 

import util.exception.IteratorException;
import util.ConditionValue;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.ListIterator;

public class ValueListHandler implements ValueListIterator, Serializable {

    static final long serialVersionUID = 1L;

    public final static int DEFAULT_ROW_PER_PAGE = 100;
    protected List list;
    protected ConditionValue conditionValue;
    protected boolean cacheFlg = false;
    protected int rowPerPage;
    protected int size = 0;
    protected int currentRowCount = 0;

    public ValueListHandler() {
        this.rowPerPage = DEFAULT_ROW_PER_PAGE;
    }

    public ValueListHandler(int rowPerPage) {
        this.rowPerPage = rowPerPage;
    }

    public boolean isCacheFlg() {
        return cacheFlg;
    }

    public void setCacheFlg(boolean newValue) {
        cacheFlg = newValue;
    }

    public int getRowPerPage() {
        return rowPerPage;
    }

    public void setRowPerPage(int newValue) {
        rowPerPage = newValue;
    }

    public String getNextPageFlg() {
        if (currentRowCount == size)
            return "false";
        return "true";
    }

    public String getPreviousPageFlg() {
        if (currentRowCount <= rowPerPage)
            return "false";
        return "true";
    }

    public String getCurrentRowCount() {
        return String.valueOf(currentRowCount);
    }

    public int getSize() {
        return size;
    }

    public String getPageSize() {
        if (rowPerPage == 0)
            return "0";
        if (size % rowPerPage == 0) {
            return String.valueOf(size / rowPerPage);
        } else
            return String.valueOf((size / rowPerPage) + 1);
    }

    public String getCurrentPage() {
        if (rowPerPage == 0)
            return "0";
        if (currentRowCount % rowPerPage == 0) {
            return String.valueOf(currentRowCount / rowPerPage);
        } else {
            return String.valueOf((currentRowCount / rowPerPage) + 1);
        }
    }

    protected void setConditionValue(ConditionValue conditionValue) {
        this.conditionValue = conditionValue;
    }

    public ConditionValue getConditionValue() {
        return this.conditionValue;
    }

    public void setList(List list) throws IteratorException {
        this.list = list;
        if (list == null) {
            throw new IteratorException("List empty");
        }
        size = list.size();
    }

    public List getList() {
        return list;
    }

    public List execute(ConditionValue conditionValue) {
        // NIY
        return null;
    }

    public List getCurrentElements() {
        if (!(this.cacheFlg))
            this.search();
        return this.getResultList(Integer.parseInt(this.getCurrentPage()));
    }

    public List getPreviousElements() {
        if (!(this.cacheFlg))
            this.search();
        return this.getResultList(Integer.parseInt(this.getCurrentPage()) - 1);
    }

    public List getNextElements() {
        if (!(this.cacheFlg))
            this.search();
        return this.getResultList(Integer.parseInt(this.getCurrentPage()) + 1);
    }

    public void resetIndex() {
        this.currentRowCount = 0;
        this.size = 0;
        this.list = null;
        this.conditionValue = null;
    }

    private List getResultList(int showPage) {

        List result = new ArrayList();
        int startRowCount = 0;
        int finalPage = 0;
        int remainder = 0;
        int _currentRowCount = 0;
    
        startRowCount = this.rowPerPage * (showPage - 1);
        finalPage = (this.size / this.rowPerPage) + 1;
        remainder = this.size % this.rowPerPage;
        if (remainder == 0) {
            finalPage = finalPage - 1;
        }

        ListIterator iterator = this.list.listIterator();

            if (finalPage < showPage) {
                startRowCount = (finalPage - 1) * this.rowPerPage;
            }
            for (int i = 0; i < startRowCount; i++) {
                if (!(iterator.hasNext())) {
                    iterator.previous();
                    break;
                }
                iterator.next();
                _currentRowCount++;
            }
            for (int i = 0; i < rowPerPage; i++) {
                if (!(iterator.hasNext())) {
                    break;
                }
                result.add(iterator.next());
                _currentRowCount++;
            }
            this.currentRowCount = _currentRowCount;
            return result;
    }

    private void cacheClear() {
        if (!isCacheFlg()) {
            this.list = null;
        }
    }

    protected void search() {
    }

}