/**
 * <p>^Cg: vWFNg "Taglib&JSTL"</p>
 * <p>: -</p>
 * <p>쌠: Copyright (c) 2005 by Taka Tazawa. All Rights Reserved.</p>
 * @author Taka Tazawa
 * @since 2005/01/30
 * @version 1.0
 */
package example007.jsp.tags; 

import java.io.IOException;
import java.sql.SQLException;
import java.util.Collection;
import java.util.Iterator;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspTagException;
import javax.servlet.jsp.tagext.TagSupport;
import util.dao.ItemDAO;
import util.dao.exception.DAOException;
import util.dao.exception.DAOFactoryException;
import util.dao.factory.DAOFactory;
import util.to.ItemTO;

public class ItemSearch extends TagSupport {

    static final long serialVersionUID = 1L;

    private String name;
    private String category;
    private StringBuffer output;

    public void setName(String name) {
        System.out.println("setName");
        this.name = name;
    }

    public void setCategory(String category) {
        System.out.println("setCategory");
        this.category = category;
    }

    public int doStartTag() throws JspException {
        System.out.println("doStartTag");

        Collection items = null;

        try {
            System.out.println(">>>>  [" + name + "] [" + category+ "]");

            ItemDAO itemDAO = null;
            DAOFactory factory = DAOFactory.getDAOFactory();

            if (name.equals("") && category.equals("")) {
                System.out.println("getItemsAll");
                itemDAO = factory.getItemDAO();
                items = itemDAO.getItemsAll();
            } else if (category.equals("")) {
                System.out.println("getItemsByName");
                itemDAO = factory.getItemDAO();
                items = itemDAO.getItemsByName(name);
            } else if (name.equals("")) {
                System.out.println("getItemsByCategory");
                itemDAO = factory.getItemDAO();
                items = itemDAO.getItemsByCategory(category);
            } else {
                System.out.println("getItemsByNameAndCategory");
                itemDAO = factory.getItemDAO();
                items = itemDAO.getItemsByNameAndCategory(name, category);
            }
        } catch(DAOException e){
            e.printStackTrace();
        } catch(DAOFactoryException e){
            e.printStackTrace();
        }

        try {
        	htmlOutput(items);
        } catch (SQLException e) {
            throw new JspTagException();
        }

        return super.doStartTag();
    }

    public int doEndTag() throws JspException {
        System.out.println("doEndTag");

        try {
            pageContext.getOut().write(output.toString());
        } catch (IOException ex) {
            throw new JspTagException();
        }

        return super.doEndTag();
    }

    private void htmlOutput(Collection items) throws SQLException {
        System.out.println("doStartTag");

        if (items == null) {
            throw new SQLException("Collection is null");
        }

        output = new StringBuffer();

        output.append("<table border=0 cellpadding=0 bgcolor=#fffffe width=100% class=\"body\">");
        output.append("<tr>");
        output.append("<td colspan=5>");
        output.append("Yi <B>");
        output.append(items.size());
        output.append("</B> ");
        output.append("</td>");
        output.append("</tr>");
        output.append("<tr bgcolor=\"#00ffff\">");
        output.append("<th>i</th>");
        output.append("<th>JeS</th>");
        output.append("<th>i</th>");
        output.append("</tr>");
        Iterator it = items.iterator();
        while (it.hasNext()) {
            ItemTO item = (ItemTO) it.next();
            output.append("<tr>");
            output.append("<td bgcolor=\"#ffffff\">");
            output.append(item.getName());
            output.append("</td>");
            output.append("<td bgcolor=\"#ffffff\">");
            output.append(item.getCategory());
            output.append("</td>");
            output.append("<td bgcolor=\"#ffffff\" align=right>");
            output.append(item.getPrice());
            output.append("~");
            output.append("</td>");
            output.append("</tr>");
        }
        output.append("</table>");
    }

} 
