<%@ tag body-content="empty" display-name="itemsearch.tag" pageEncoding="Shift_JIS" dynamic-attributes="dynamicAttributes"%>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="sql" uri="http://java.sun.com/jsp/jstl/sql" %>
<%@ taglib prefix="fn"  uri="http://java.sun.com/jsp/jstl/functions" %>

<%@ variable name-given="_category" %>
<%@ variable name-given="_name" %>

<c:forTokens
  items="${fn:substringBefore(fn:substringAfter(dynamicAttributes, '{'), '}')}"
  delims=","
  var="attribute">

    <c:if test="${fn:contains(attribute, '_category')}">
        <c:set var="_category" value="${fn:substringAfter(attribute, '_category=')}" />
        ${_category}
    </c:if>
    <c:if test="${fn:contains(attribute, '_name')}">
        <c:set var="_name" value="${fn:substringAfter(attribute, '_name=')}" />
        ${_name}
    </c:if>

</c:forTokens>

 JeS: [${_category}] i: [${_name}]<br><br>

<%@ variable name-given="items" variable-class="javax.servlet.jsp.jstl.sql.Result" scope="AT_END" %>
<%@ variable name-given="rowcount" variable-class="java.lang.Integer" scope="AT_END" %>

<sql:setDataSource dataSource="jdbc/MyDataSource" var="ds" scope="page"/>

<c:set var="SQLSELECT" value="SELECT ITEM.ITEM_ID, ITEM.NAME, CATEGORY.CATEGORY_NAME, ITEM.PRICE, ITEM.DETAIL, ITEM.INVALIDATED_DATE, ITEM.LEAD_TIME, ITEM.REGISTRATION_DATE FROM ITEM, CATEGORY WHERE ITEM.CATEGORY_ID=CATEGORY.CATEGORY_ID " />
<c:set var="SQLORDERBY" value="ORDER BY ITEM_ID " />

<c:choose>
    <c:when test="${(empty _category) && (empty _name)}">
        <c:set var="sqlWhere" value="" />
        <sql:query sql="${SQLSELECT} ${sqlWhere} ${SQLORDERBY}"
          var="result"
          scope="page"
          dataSource="${ds}" />
    </c:when>
    <c:when test="${(empty _category)}">
        <c:set var="sqlWhere" value="AND ITEM.NAME LIKE ? " />
        <sql:query sql="${SQLSELECT} ${sqlWhere} ${SQLORDERBY}"
          var="result"
          scope="page"
          dataSource="${ds}" >
          <sql:param value="%${_name}%"/>
        </sql:query>
    </c:when>
    <c:when test="${(empty _name)}">
        <c:set var="sqlWhere" value="AND ITEM.CATEGORY_ID = ? " />
        <sql:query sql="${SQLSELECT} ${sqlWhere} ${SQLORDERBY}"
          var="result"
          scope="page"
          dataSource="${ds}" >
          <sql:param value="${_category}"/>
        </sql:query>
    </c:when>
    <c:otherwise>
        <c:set var="sqlWhere" value="AND ITEM.NAME LIKE ? AND ITEM.CATEGORY_ID = ? " />
        <sql:query
          var="result"
          scope="page"
          dataSource="${ds}" >
          ${SQLSELECT} ${sqlWhere} ${SQLORDERBY}
          <sql:param value="%${_name}%"/>
          <sql:param value="${_category}"/>
        </sql:query>
    </c:otherwise>
</c:choose>

<c:set var="rowcount" value="${result.rowCount}" />
<c:set var="items" value="${result}" />
